<template>
  <div class="list-container">
    <div v-if="showListPage">
      <el-button type="primary" icon="el-icon-back" circle plain @click="backToQuery()" />
      <el-table :data="$attrs.datalist" border stripe size="mini">
        <el-table-column label="#" min-width="30" align="center" show-overflow-tooltip>
          <template slot-scope="scope">
            <div>{{ rowNum(scope.$index) }}</div>
          </template>
        </el-table-column>
        <el-table-column prop="regionId" label="地區代號" />
        <el-table-column prop="custId" label="客戶代號" />
        <el-table-column prop="personType" label="客戶類別" show-overflow-tooltip />
        <el-table-column prop="locName" label="本地名字" show-overflow-tooltip />
        <el-table-column prop="engName" label="英文名字" show-overflow-tooltip />
        <el-table-column prop="custLevel" label="客戶等級" show-overflow-tooltip />
        <el-table-column prop="personId" label="身分證號" />
        <el-table-column fixed="right" label="編輯" width="150">
          <template slot-scope="scope">
            <el-button
              icon="el-icon-edit"
              circle
              type="primary"
              size="mini"
              @click="update(scope.row)"
            />
            <el-button
              icon="el-icon-delete"
              circle
              type="danger"
              size="mini"
              @click="remove(scope.row)"
            />
            <el-button icon="el-icon-search" circle size="mini" @click="view(scope.row)" />
          </template>
        </el-table-column>
      </el-table>
      <el-pagination
        background
        :page-size="$attrs.condition.pageSize"
        :total="$attrs.condition.total"
        :current-page="$attrs.condition.current"
        layout="slot, ->, prev, pager, next, total, jumper"
        @current-change="doQuery"
      />
    </div>
    <Detail
      v-if="!showListPage"
      :condition="$attrs.condition"
      :model="model"
      :visible.sync="showListPage"
    />
  </div>
</template>

<script>
import Detail from './Detail'
import { countRowNum } from '@/utils/common'

export default {
  components: {
    Detail
  },
  inheritAttrs: false,
  data() {
    return {
      showDetailPage: false,
      showListPage: true,
      model: null,
      counter: true
    }
  },
  computed: {

  },
  watch: {
    showListPage: function () {
      console.log(`---------------showListPage--------------------`)
      console.log(`showListPage = ${this.showListPage}`)
      console.log(`showDetailPage = ${this.showDetailPage}`)
    }
  },
  methods: {
    update(row) {
      this.model = Object.assign({}, row)
      this.title = '修改'
      this.showListPage = false
      this.showDetailPage = true
    },
    remove(row) {
      this.model = Object.assign({}, row)
      this.title = '刪除'
      this.showDetailPage = true
    },
    view(row) {
      this.model = Object.assign({}, row)
      this.title = '檢視'
      this.showDetailPage = true
    },
    close(done) {
      this.showDetailPage = false
      this.$confirm('確認關閉？')
        .then(_ => {
          done()
        })
        .catch(_ => { })
    },
    rowNum(index) {
      return countRowNum(this.$attrs.current, this.$attrs.pageSize, index)
    },
    doQuery(current) {
      this.$emit('doQuery', current)
    },
    backToQuery() {
      // this.$emit('backToQuery')
      this.$emit('update:visible', true)
    }
  }
}
</script>

<style>
</style>
